#include "stdafx.h"
#include "CppUnitTest.h"
#include "../cs242FinalExam/IHashTable.h"
#include "../cs242FinalExam/LPHashTable.h"

using namespace Microsoft::VisualStudio::CppUnitTestFramework;


// Complete these tests, adding more if appropriate as you implement
// a basic Hash Table class that uses linear probes to resolve collisions.
// Rewrite the functions in LPHashTable as necessary.
namespace UnitTest1
{		
	TEST_CLASS(UnitTest1)
	{
	public:
		
		TEST_METHOD(createTable)
		{
			// Create a table for an estimated 100 entries
			// Explain the table size selection in you comments.
			const int estimatedEntries = 100;
			LPHashTable<int> myHashTable(estimatedEntries);
		}
		
		TEST_METHOD(containsFailure)
		{
			// Lookup an item that is not in the table
			const int estimatedEntries = 100;
			LPHashTable<int> myHashTable(estimatedEntries);
			Assert::IsFalse(myHashTable.contains("Kasparov"));
		}

		TEST_METHOD(insertElement)
		{
			// Insert an element into the table
			const int estimatedEntries = 100;
			LPHashTable<int> myHashTable(estimatedEntries);
			myHashTable.insert("Kasparov", 2700);
		}

		TEST_METHOD(containsSucceeding)
		{
			// Lookup an item that is not in the table
			const int estimatedEntries = 100;
			LPHashTable<int> myHashTable(estimatedEntries);
			myHashTable.insert("Kasparov", 2700);
			Assert::IsTrue(myHashTable.contains("Kasparov"));
		}

		TEST_METHOD(lookupSucceeding)
		{
			// Lookup an item that is not in the table
			const int estimatedEntries = 100;
			LPHashTable<int> myHashTable(estimatedEntries);
			myHashTable.insert("Kasparov", 2700);
			Assert::AreEqual(2700, myHashTable.lookup("Kasparov"));
		}

		TEST_METHOD(nCollisionTest)
		{
			// Report the number of collisions that the class has
			// encountered 
			const int estimatedEntries = 100;
			LPHashTable<int> myHashTable(estimatedEntries);
			myHashTable.insert("Kasparov", 2700);
			Assert::AreEqual(0, myHashTable.getNCollisions());
		}

	};
}