#pragma once
#include <string>

template <typename Type>
class IHashTable 
{
public:
	virtual unsigned int hash(const std::string& key) const = 0;
	virtual bool contains(const std::string& key) const = 0;
	virtual Type lookup(const std::string& key) const = 0;
	virtual void insert(const std::string& key, 
		const Type& thingToInsert) = 0;
	virtual ~IHashTable();
};

template <typename Type>
IHashTable<Type>::~IHashTable()
{
}
